<?php
/**
 * WP Background Process
 *
 * Based on WP Background Processing by Delicious Brains: https://github.com/deliciousbrains/wp-background-processing/blob/master/classes/wp-background-process.php
 */

declare( strict_types=1 );

namespace FiboFilters\Indexer\BackgroundProcessing;

use FiboFilters\Indexer\BuildInfo;
use FiboFilters\Indexer\Config;
use FiboFilters\Indexer\Logger;
use FiboFilters\WP\Helper as WPHelper;
use stdClass;

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * Abstract BackgroundProcess class.
 */
abstract class BackgroundProcess extends AsyncRequest {

	/**
	 * Action
	 *
	 * (default value: 'background_process')
	 *
	 * @var string
	 * @access protected
	 */
	protected $action = 'background_process';

	/**
	 * Start time of current process.
	 *
	 * (default value: 0)
	 *
	 * @var int
	 * @access protected
	 */
	protected $start_time = 0;

	/**
	 * Cron_hook_identifier
	 *
	 * @var mixed
	 * @access protected
	 */
	protected $cron_hook_identifier;

	/**
	 * Cron_interval_identifier
	 *
	 * @var mixed
	 * @access protected
	 */
	protected $cron_interval_identifier;

	/**
	 * Queue save result
	 *
	 * @var bool
	 */
	protected $save_result = true;

	/** @var string */
	protected $call_source = '';

	/** @var BuildInfo */
	protected $build_info;

	/** @var Config */
	protected $config;

	/** @var Logger */
	protected $logger;

	/** @var WPHelper */
	protected $wp_helper;

	/**
	 * Initiate new background process
	 */
	public function __construct( BuildInfo $build_info, Config $config, Logger $logger, WPHelper $wp_helper ) {
		parent::__construct( $logger );

		$this->build_info = $build_info;
		$this->config     = $config;
		$this->wp_helper  = $wp_helper;

		$this->cron_hook_identifier     = $this->identifier . '_cron';
		$this->cron_interval_identifier = $this->identifier . '_cron_interval';
	}

	public function init_cron(): void {
		add_action( $this->cron_hook_identifier, [ $this, 'handle_cron_healthcheck' ] );
		add_filter(
			'cron_schedules', // phpcs:ignore WordPress.WP.CronInterval
			[
				$this,
				'schedule_cron_healthcheck',
			]
		);
	}

	/**
	 * Dispatch
	 */
	public function dispatch(): array { // phpcs:ignore Generic.Metrics.CyclomaticComplexity.MaxExceeded,Generic.Metrics.NestingLevel.MaxExceeded
		// Perform remote post.
		parent::dispatch();

		// Schedule the cron healthcheck.
		$this->schedule_event();

		$status = $this->build_info->get_info( 'status', $this->config->get_index_role() );
		if ( $status !== 'building' ) {
			$this->logger->log( $this->name . ' Breaking background process due to indexer status: ' . $status, 'debug', 'file', 'bg-process' );
			exit();
		}

		// Wait 15s and redispatch process if queue is not empty and process is not running.
		$redispatch_process = apply_filters( 'fibofilters/indexer/redispatch_not_running_process', true );
		if ( $redispatch_process ) {
			for ( $i = 1; $i <= 10; $i++ ) {
				$sleep = $i <= 5 ? 1 : 2;
				sleep( $sleep );

				$is_empty   = $this->is_queue_empty();
				$is_running = $this->is_process_running();
				if ( $is_empty || $is_running ) {
					$this->logger->log( $this->name . ' Breaking redispatch process | Loop: ' . $i . ' | Empty: ' . ( $is_empty ? 'true' : 'false' ) . ' | Is running: ' . ( $is_running ? 'true' : 'false' ), 'debug', 'file', 'bg-process' );

					return [];
				}

				if ( ! in_array( $this->build_info->get_info( 'status', $this->config->get_index_role() ), [ 'building' ], true ) ) {
					return [];
				}
			}

			if ( ! $this->is_queue_empty() && ! $this->is_process_running() ) {
				// Set default timeout and blocking, so we can get and check response.
				add_filter(
					"fibofilters/{$this->identifier}/post_args",
					function ( array $args ): array {
						if ( isset( $args['timeout'] ) ) {
							unset( $args['timeout'] );
						}
						if ( isset( $args['blocking'] ) ) {
							unset( $args['blocking'] );
						}
						// Prevent error: "400 Bad Request: Request Header Or Cookie Too Large".
						if ( isset( $args['cookies'] ) && is_array( $args['cookies'] ) ) {
							foreach ( $args['cookies'] as $index => $cookie ) {
								if ( strlen( $cookie ) > 250 ) {
									$args['cookies'][ $index ] = '';
								}
							}
						}

						return $args;
					}
				);

				$this->logger->log( $this->name . ' Redispatching process', 'debug', 'file', 'bg-process' );

				$response = parent::dispatch();
				if ( wp_remote_retrieve_response_code( $response ) !== 200 || is_wp_error( $response ) ) {
					if ( is_wp_error( $response ) ) {
						$this->logger->log( $this->name . ' Redispatch process error: ' . $response->get_error_message() . ' | Code: ' . $response->get_error_code(), 'debug', 'file', 'bg-process' );
					} else {
						$this->logger->log( $this->name . ' Redispatch process error response | Code: ' . wp_remote_retrieve_response_code( $response ) . ' | Message: ' . wp_remote_retrieve_response_message( $response ) . ' | Body: ' . substr( wp_remote_retrieve_body( $response ), 0, 1000 ), 'debug', 'file', 'bg-process' );
					}
				}
			}
		}

		return [];
	}

	/**
	 * Push to queue
	 *
	 * @param mixed $data Data.
	 *
	 * @return $this
	 */
	public function push_to_queue( $data ) {
		$this->data[] = $data;

		return $this;
	}

	/**
	 * Save queue
	 *
	 * @return $this
	 */
	public function save() {
		$key = $this->generate_key();

		if ( ! empty( $this->data ) ) {
			$this->save_result = update_site_option( $key, $this->data );
		}

		return $this;
	}

	/**
	 * Update queue
	 *
	 * @param string $key Key.
	 * @param array  $data Data.
	 *
	 * @return $this
	 */
	public function update( string $key, array $data ) {
		if ( ! empty( $data ) ) {
			update_site_option( $key, $data );
		}

		return $this;
	}

	/**
	 * Delete queue
	 *
	 * @param string $key Key.
	 *
	 * @return $this
	 */
	public function delete( string $key ) {
		delete_site_option( $key );

		return $this;
	}

	/**
	 * Generate key
	 *
	 * Generates a unique key based on microtime. Queue items are
	 * given a unique key so that they can be merged upon save.
	 *
	 * @param int $length Length.
	 */
	protected function generate_key( int $length = 64 ): string {
		$unique  = md5( microtime() . wp_rand() );
		$prepend = $this->identifier . '_batch_';

		return substr( $prepend . $unique, 0, $length );
	}

	/**
	 * Maybe process queue
	 *
	 * Checks whether data exists within the queue and that
	 * the process is not already running.
	 */
	public function maybe_handle(): void {
		// Don't lock up other requests while processing.
		session_write_close();

		$this->logger->log( $this->name . ' Maybe handle process', 'debug', 'file', 'bg-process' );

		if ( $this->is_process_running() ) {
			$this->logger->log( $this->name . ' Maybe handle process. Stop: background process already running', 'debug', 'file', 'bg-process' );
			// Background process already running.
			wp_die();
		}

		if ( $this->is_queue_empty() ) {
			$this->logger->log( $this->name . ' Maybe handle process. Stop: no data to process', 'debug', 'file', 'bg-process' );
			// No data to process.
			wp_die();
		}

		$check_nonce = check_ajax_referer( $this->identifier, 'nonce', false );
		if ( ! $check_nonce ) {
			$this->logger->log( $this->name . ' Maybe handle process. Stop: invalid nonce', 'debug', 'file', 'bg-process' );

			if ( wp_doing_ajax() ) {
				wp_die( '-1', 403 );
			} else {
				die( '-1' );
			}
		}

		$this->call_source = 'ajax';
		$this->handle();

		wp_die();
	}

	/**
	 * Get queue save result
	 */
	public function get_save_result(): bool {
		return $this->save_result;
	}

	/**
	 * Is queue empty
	 */
	protected function is_queue_empty(): bool {
		global $wpdb;

		$table  = $wpdb->options;
		$column = 'option_name';

		if ( is_multisite() ) {
			$table  = $wpdb->sitemeta;
			$column = 'meta_key';
		}

		$key = $wpdb->esc_like( $this->identifier . '_batch_' ) . '%';

		// phpcs:disable WordPress.DB.PreparedSQL.InterpolatedNotPrepared
		$count = $wpdb->get_var(
			$wpdb->prepare(
				"
			SELECT SQL_NO_CACHE COUNT(*)
			FROM {$table}
			WHERE {$column} LIKE %s
		",
				$key
			)
		);
		// phpcs:enable WordPress.DB.PreparedSQL.InterpolatedNotPrepared

		return ( $count > 0 ) ? false : true;
	}

	/**
	 * Is process running
	 *
	 * Check whether the current process is already running
	 * in a background process.
	 */
	protected function is_process_running(): bool {
		$lock_duration = ( property_exists( $this, 'queue_lock_time' ) ) ? $this->queue_lock_time : 60; // 1 minute
		$lock_duration = apply_filters( 'fibofilters/' . $this->identifier . '_queue_lock_time', $lock_duration );

		if ( $this->wp_helper->is_lock_locked( $this->identifier . '_process_lock', $lock_duration ) ) {
			// Process already running.
			return true;
		}

		return false;
	}

	/**
	 * Lock process
	 *
	 * Lock the process so that multiple instances can't run simultaneously.
	 * Override if applicable, but the duration should be greater than that
	 * defined in the time_exceeded() method.
	 */
	protected function lock_process(): void {
		$this->start_time = time(); // Set start time of current process.
		$this->wp_helper->set_lock( $this->identifier . '_process_lock' );
	}

	/**
	 * Update process lock
	 */
	public function update_lock(): void {
		$this->wp_helper->set_lock( $this->identifier . '_process_lock' );
	}

	/**
	 * Unlock process
	 *
	 * Unlock the process so that other instances can spawn.
	 *
	 * @return $this
	 */
	protected function unlock_process() {
		$this->wp_helper->unlock_lock( $this->identifier . '_process_lock' );

		return $this;
	}

	/**
	 * Get batch
	 *
	 * @return stdClass Return the first batch from the queue
	 */
	protected function get_batch(): stdClass {
		global $wpdb;

		$table        = $wpdb->options;
		$column       = 'option_name';
		$key_column   = 'option_id';
		$value_column = 'option_value';

		if ( is_multisite() ) {
			$table        = $wpdb->sitemeta;
			$column       = 'meta_key';
			$key_column   = 'meta_id';
			$value_column = 'meta_value';
		}

		$key = $wpdb->esc_like( $this->identifier . '_batch_' ) . '%';

		// phpcs:disable WordPress.DB.PreparedSQL.InterpolatedNotPrepared
		$query = $wpdb->get_row(
			$wpdb->prepare(
				"SELECT SQL_NO_CACHE *
				FROM {$table}
				WHERE {$column} LIKE %s
				ORDER BY {$key_column} ASC
				LIMIT 1",
				$key
			)
		);
		// phpcs:enable WordPress.DB.PreparedSQL.InterpolatedNotPrepared

		$batch       = new stdClass();
		$batch->key  = $query->$column;
		$batch->data = maybe_unserialize( $query->$value_column );

		return $batch;
	}

	/**
	 * Handle
	 *
	 * Pass each queue item to the task handler, while remaining
	 * within server memory and time limit constraints.
	 */
	protected function handle(): void {
		$this->lock_process();

		$this->logger->log( $this->name . ' Locking and handling process', 'debug', 'file', 'bg-process' );

		do {
			$batch = $this->get_batch();

			foreach ( $batch->data as $key => $value ) {
				$task = $this->task( $value );

				if ( $task !== false ) {
					$batch->data[ $key ] = $task;
				} else {
					unset( $batch->data[ $key ] );
				}

				if ( $this->time_exceeded() || $this->memory_exceeded() ) {
					// Batch limits reached.
					break;
				}

				if ( $this->indexing_error_occurred() ) {
					// Abort due to indexer error.
					break;
				}
			}

			// Update or delete current batch.
			if ( ! empty( $batch->data ) ) {
				$this->update( $batch->key, $batch->data );
			} else {
				$this->delete( $batch->key );
			}
		} while ( ! $this->time_exceeded( true ) && ! $this->memory_exceeded() && ! $this->is_queue_empty() && ! $this->indexing_error_occurred() );

		$this->unlock_process();

		if ( $this->indexing_error_occurred() ) {
			// Abort due to indexer error.
			wp_die();
		}

		// Start next batch or complete process.
		if ( ! $this->is_queue_empty() ) {
			$this->logger->log( $this->name . ' Process handled and unlocked. Queue is not empty. Dispatching next process', 'debug', 'file', 'bg-process' );
			$this->dispatch();
		} else {
			$this->logger->log( $this->name . ' Process handled and unlocked. Queue is empty. Complete', 'debug', 'file', 'bg-process' );
			$this->complete();
		}

		wp_die();
	}

	/**
	 * Memory exceeded
	 *
	 * Ensures the batch process never exceeds 90%
	 * of the maximum WordPress memory.
	 */
	protected function memory_exceeded(): bool {
		$memory_limit   = intval( $this->get_memory_limit() * 0.9 ); // 90% of max memory
		$current_memory = memory_get_usage( true );
		$return         = false;

		if ( $current_memory >= $memory_limit ) {
			$this->logger->log( $this->name . ' Batch memory exceeded: ' . size_format( $current_memory ) . '/' . size_format( $memory_limit ), 'debug', 'file', 'bg-process' );
			$return = true;
		}

		return apply_filters( 'fibofilters/' . $this->identifier . '/memory_exceeded', $return );
	}

	/**
	 * Get memory limit
	 */
	protected function get_memory_limit(): int {
		if ( function_exists( 'ini_get' ) ) {
			$memory_limit = ini_get( 'memory_limit' );
		} else {
			// Sensible default.
			$memory_limit = '128M';
		}

		if ( ! $memory_limit || - 1 === intval( $memory_limit ) ) {
			// Unlimited, set to 32GB.
			$memory_limit = '32000M';
		}

		return wp_convert_hr_to_bytes( $memory_limit );
	}

	/**
	 * Time exceeded.
	 *
	 * Ensures the batch never exceeds a sensible time limit.
	 * A timeout limit of 30s is common on shared hosting.
	 *
	 * @param bool $log Write log if time is over limit.
	 *
	 * @return bool
	 */
	protected function time_exceeded( bool $log = false ): bool {
		// phpcs:ignore WordPress.NamingConventions.PrefixAllGlobals.DynamicHooknameFound
		$finish = $this->start_time + apply_filters( $this->identifier . '_default_time_limit', 20 ); // 20 seconds.
		$return = false;

		if ( time() >= $finish ) {
			if ( $log ) {
				// phpcs:ignore WordPress.NamingConventions.PrefixAllGlobals.DynamicHooknameFound
				$this->logger->log( $this->name . ' Batch time exceeded: ' . ( time() - $this->start_time ) . '/' . apply_filters( $this->identifier . '_default_time_limit', 20 ) . 's', 'debug', 'file', 'bg-process' );
			}
			$return = true;
		}

		// phpcs:ignore WordPress.NamingConventions.PrefixAllGlobals.DynamicHooknameFound
		return apply_filters( $this->identifier . '_time_exceeded', $return );
	}

	protected function indexing_error_occurred(): bool {
		$status = $this->build_info->get_info( 'status', $this->config->get_index_role() );

		return $status === 'error';
	}

	/**
	 * Complete.
	 *
	 * Override if applicable, but ensure that the below actions are
	 * performed, or, call parent::complete().
	 */
	protected function complete(): void {
		// Unschedule the cron healthcheck.
		$this->clear_scheduled_event();
	}

	/**
	 * Schedule cron healthcheck
	 *
	 * @access public
	 *
	 * @param array $schedules Schedules.
	 */
	public function schedule_cron_healthcheck( array $schedules ): array {
		$interval = apply_filters( 'fibofilters/indexer/' . $this->identifier . '/cron_interval', 5 );

		if ( property_exists( $this, 'cron_interval' ) ) {
			$interval = apply_filters( 'fibofilters/indexer/' . $this->identifier . '/cron_interval', $this->cron_interval );
		}

		// Adds every 5 minutes to the existing schedules.
		$schedules[ $this->identifier . '_cron_interval' ] = [
			'interval' => MINUTE_IN_SECONDS * $interval,
			/* translators: %d interval */
			'display'  => sprintf( _x( 'Every %d minutes', '[admin]', 'fibofilters' ), $interval ),
		];

		return $schedules;
	}

	/**
	 * Handle cron healthcheck
	 *
	 * Restart the background process if not already running
	 * and data exists in the queue.
	 */
	public function handle_cron_healthcheck(): void {
		for ( $i = 0; $i < 2; $i++ ) {
			if ( $this->is_process_running() ) {
				// Background process already running.
				exit;
			}
			sleep( 2 );
		}

		if ( $this->is_queue_empty() ) {
			// No data to process.
			$this->clear_scheduled_event();
			exit;
		}

		if ( $this->build_info->is_indexer_working_too_long( 80 ) ) {
			$this->logger->log( $this->name . ' Handle process via cron healthcheck', 'debug', 'file', 'bg-process' );
			$this->call_source = 'cron';
			$this->handle();
		}

		exit;
	}

	/**
	 * Schedule event
	 */
	protected function schedule_event(): void {
		if ( ! wp_next_scheduled( $this->cron_hook_identifier ) ) {
			wp_schedule_event( time(), $this->cron_interval_identifier, $this->cron_hook_identifier );
		}
	}

	/**
	 * Clear scheduled event
	 */
	protected function clear_scheduled_event(): void {
		$timestamp = wp_next_scheduled( $this->cron_hook_identifier );

		if ( $timestamp ) {
			wp_unschedule_event( $timestamp, $this->cron_hook_identifier );
		}
	}

	/**
	 * Cancel Process
	 *
	 * Stop processing queue items, clear cronjob and delete batch.
	 */
	public function cancel_process(): void {
		if ( ! $this->is_queue_empty() ) {
			$batch = $this->get_batch();

			$this->delete( $batch->key );
		}

		wp_clear_scheduled_hook( $this->cron_hook_identifier );

		$this->unlock_process();
	}

	/**
	 * Task
	 *
	 * Override this method to perform any actions required on each
	 * queue item. Return the modified item for further processing
	 * in the next pass through. Or, return false to remove the
	 * item from the queue.
	 *
	 * @param mixed $item Queue item to iterate over.
	 *
	 * @return mixed
	 */
	abstract protected function task( $item );
}
